Subject: Re: bug#33509: core-updates: arc-theme fails with "Invalid GNOME version: 3.24"

From: Björn Höfling <[email-masked]>
Date: Tue, 27 Nov 2018 16:07:45 +0100

On Mon, 26 Nov 2018 23:00:33 +0200
Efraim Flashner <[email-masked]> wrote:

> On Mon, Nov 26, 2018 at 12:55:15PM +0100, Björn Höfling wrote:
> > On core-updates the package arc-theme fails:
> > 
> > starting phase `configure'
> > source directory:
> > "/tmp/guix-build-arc-theme-20170302.drv-0/arc-theme-20170302" build
> > directory:
> > "/tmp/guix-build-arc-theme-20170302.drv-0/arc-theme-20170302"
> > configure flags:
> > ("CONFIG_SHELL=/gnu/store/q19l04vd2za80mk1845pz7r8cz29qk43-bash
> > configure: WARNING: unrecognized options: --enable-fast-install
> > checking for a BSD-compatible
> > install... /gnu/store/5s2nib1lrd2101bbrivcl17kjx1m checking whether
> > build environment is sane... yes checking for a thread-safe mkdir
> > -p... /gnu/store/5s2nib1lrd2101bbrivcl17kjx1msp checking for
> > gawk... gawk checking whether make sets $(MAKE)... no checking
> > whether make supports nested variables... yes checking for
> > pkg-config... /gnu/store/xyiyf12w4i7zf5g5b4ah0bi1mmd6i8xa-pkg-confi
> > checking pkg-config is at least version 0.9.0... yes configure:
> > error: Invalid GNOME version: 3.24
> > 
> > It seams that only GNOME versions until 3.22 are valid.
> > 
> > Nix has a workaround that sets the version down:
> > 
> > https://github.com/NixOS/nixpkgs/commit/165fa89762d7156bb3f2774cd3ff0d40cd0a9606
> > 
> > If I set the version hard to 3.22 the package builds again
> > successfully:
> > 
> > -     '(#:phases
> > +     '(#:configure-flags
> > +       '("--with-gnome=3.22")
> > +       #:phases
> > 
> > Is it legitimate to patch it like that or do we need more tests?
> > 
> > Björn
> >   
> 
> I'd look into if you can use (version-major+minor (package-version
> gnome)) so it doesn't have to be updated.
> 
> 

Hi Efraim,

I don't know what you mean with "so it doesn't have to be updated"? I
mean changing the package definition is an update?

Also, I don't know what your intention with "version-major+minor" is?
On core-updates the current version of gnome is "3.24.3".
Then (version-major+minor gnome-version) would still evaluate to 3.24,
which IS too big, 3.22 is the maximum accepted version. 

Let me explain a bit more: With adding "--with-gnome=3.22" we are
pretending the configure-script that we will use gnome-3.22, although
we still use the latest version (To be precise, we use gtk+, but that
seams to report the gnome-version with pkg-config). 

This version number is then used to search in the directory

/tmp/guix-build-arc-theme-20170302.drv-0/arc-theme-20170302/common/gtk-3.0

the matching "major.minor" version, choosing the right theme.

3.22 is already symlinking to 3.20, and that is the highest available
real directory.

So we might get wrong look&feel here, because it is not adapted to
GNOME 3.24. But there is no further development upstream anyway. If it
doesn't look totally malformed, we can use it like that. My disk is a
bit full, I can't do a vm-image with it currently.

Björn